﻿'A reference to the Phidget22.NET.dll must be added to new projects in VB.Net 
'From the "Project" menu select "Add Reference" 
'From the "Add Reference" window select the "Browse" tab 
'Browse to the directory you installed the Phidgets library to 
'The default is "C:\Program Files\Phidgets" 
'Select "Phidget22.NET.dll" and click "OK" 
'To view objects that have been added, select the "View" menu 
'Select "Object Browser" 
'Then expand the Phidget22.NET.dll item 



Imports Phidget22
Imports Phidget22.Events

Public Class Form1
    Dim WithEvents device As Phidget22.DCMotor
    Dim open As ExampleUtils.ExampleUtils.CommandLineOpen
    Dim errorBox As ErrorEventBox

    Public Sub New()
        open = New ExampleUtils.ExampleUtils.CommandLineOpen(Me)
        Phidget22.Phidget.InvokeEventCallbacks = True
        InitializeComponent()
    End Sub

    Public Sub New(ByVal commandLine As String())
        open = New ExampleUtils.ExampleUtils.CommandLineOpen(Me)
        open.commandLine = commandLine
        Phidget22.Phidget.InvokeEventCallbacks = True
        InitializeComponent()
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        errorBox = New ErrorEventBox(Me)
        device = New Phidget22.DCMotor()

        'open the device
        Dim phidgetParameters As ExampleUtils.commandLineData = open.parseCmdLine()

        Try 'set all the values grabbed from command line.  these values have defaults that are set in ExampleUtils.vb, you can check there to see them
            device.Channel = phidgetParameters.Channel 'selects the channel on the device to open
            device.DeviceSerialNumber = phidgetParameters.SerialNumber 'selects the device or hub to open
            device.HubPort = phidgetParameters.HubPort 'selects th eport on the hub to open
            device.IsHubPortDevice = phidgetParameters.isHubPortDevice 'is the device a port on a vint hub?

            If phidgetParameters.isRemote Then 'are we trying to open a remote device?
                device.IsRemote = True
                Net.EnableServerDiscovery(ServerType.Device) 'turn on network scan
                If phidgetParameters.Password <> vbNullString And phidgetParameters.ServerName <> vbNullString Then
                    Net.SetServerPassword(phidgetParameters.ServerName, phidgetParameters.Password)
                End If
            Else
                device.IsLocal = True
            End If

            device.Open() 'open the device specified by the above parameters
        Catch ex As PhidgetException
            errorBox.addMessage("Error opening the device: " + ex.Message)
        End Try
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Application.DoEvents()
        If device.Attached Then
            device.Close()
        End If
    End Sub

    Private Sub device_Attach(ByVal sender As Object, ByVal e As AttachEventArgs) Handles device.Attach
        Dim attachedDevice As Phidget22.DCMotor = CType(sender, Phidget22.DCMotor)
        PhidgetInfoBox1.FillPhidgetInfo(attachedDevice)

        accelerationTrk.Minimum = Convert.ToInt32(Math.Ceiling(100 * attachedDevice.MinAcceleration))
        accelerationTrk.Maximum = Convert.ToInt32(Math.Ceiling(100 * attachedDevice.MaxAcceleration))
        accelMinLbl.Text = (accelerationTrk.Minimum / 100).ToString()
        accelMaxLbl.Text = (accelerationTrk.Maximum / 100).ToString()

        accelTxt.Text = attachedDevice.MinAcceleration.ToString() + " %dty/s²"

        dtycycletrk.Value = 0
        dutyTxt.Text = "0"

        brakingStrengthTrk.Value = 0
        brakingTxt.Text = "0"

        Select Case device.DeviceID 'initialize various form controls
            Case DeviceID.PN_1060
                backEmfSensingChk.Visible = False
                backEMFLabel.Visible = False
                backEMFTxt.Visible = False
                brakingStrengthTrk.Visible = False
                brakingTxt.Visible = False
                brakingLbl.Visible = False
                brakingMinLbl.Visible = False
                brakingMaxLbl.Visible = False
                label9.Visible = False
                currentRegTrk.Visible = False
                currentRegLbl.Visible = False
                currentRegMaxLbl.Visible = False
                currentRegMinLbl.Visible = False
                label5.Visible = False
                currentLimitLbl.Visible = False
                fanModeLbl.Visible = False
                fanModeCombo.Visible = False
                currentLimitMinLbl.Visible = False
                currentLimMaxLbl.Visible = False
                currentLimitTrk.Visible = False
            Case DeviceID.PN_1064
                backEmfSensingChk.Visible = False
                backEMFLabel.Visible = False
                backEMFTxt.Visible = False
                brakingStrengthTrk.Visible = False
                brakingTxt.Visible = False
                brakingLbl.Visible = False
                brakingMinLbl.Visible = False
                brakingMaxLbl.Visible = False
            Case DeviceID.PN_1065
                label9.Visible = False
                currentRegTrk.Visible = False
                currentRegLbl.Visible = False
                currentRegMaxLbl.Visible = False
                currentRegMinLbl.Visible = False
                fanModeLbl.Visible = False
                fanModeCombo.Visible = False
                brakingStrengthTrk.Visible = False
                brakingTxt.Visible = False
                brakingLbl.Visible = False
                brakingMinLbl.Visible = False
                brakingMaxLbl.Visible = False
                backEmfSensingChk.Visible = True
                backEMFLabel.Visible = True
                backEMFTxt.Visible = True
                label5.Visible = False
                currentLimitLbl.Visible = False
                currentLimitMinLbl.Visible = False
                currentLimMaxLbl.Visible = False
                currentLimitTrk.Visible = False
                Try
                    device.BackEMFSensingState = backEmfSensingChk.Checked
                Catch ex As PhidgetException
                    errorBox.addMessage("Error setting BackEMFSensingState: " + ex.Message)
                End Try
            Case DeviceID.PN_DCC1000
                backEmfSensingChk.Visible = False
                backEMFLabel.Visible = False
                backEMFTxt.Visible = False
                label9.Visible = True
                currentRegTrk.Visible = True
                currentRegLbl.Visible = True
                currentRegMaxLbl.Visible = True
                currentRegMinLbl.Visible = True
                fanModeLbl.Visible = True
                fanModeCombo.Visible = True
                brakingStrengthTrk.Visible = True
                brakingTxt.Visible = True
                brakingLbl.Visible = True
                brakingMinLbl.Visible = True
                brakingMaxLbl.Visible = True
                label5.Visible = True
                currentLimitLbl.Visible = True
                currentLimitMinLbl.Visible = True
                currentLimMaxLbl.Visible = True
                currentLimitTrk.Visible = True
                fanModeCombo.SelectedIndex = 2
                currentRegMinLbl.Text = device.MinCurrentRegulatorGain.ToString()
                currentRegMaxLbl.Text = device.MaxCurrentRegulatorGain.ToString()
                currentLimitMinLbl.Text = device.MinCurrentLimit.ToString()
                currentLimMaxLbl.Text = device.MaxCurrentLimit.ToString()
                currentLimitTrk.Minimum = Convert.ToInt32(device.MinCurrentLimit)
                currentLimitTrk.Maximum = Convert.ToInt32(device.MaxCurrentLimit)
                currentRegTrk.Minimum = Convert.ToInt32(device.MinCurrentRegulatorGain)
                currentRegTrk.Maximum = Convert.ToInt32(device.MaxCurrentRegulatorGain)
                brakingMinLbl.Text = "0"
                brakingStrengthTrk.Minimum = 0
            Case DeviceID.PN_DCC1001
                backEmfSensingChk.Visible = False
                backEMFLabel.Visible = False
                backEMFTxt.Visible = False
                currentRegMinLbl.Visible = False
                currentRegMaxLbl.Visible = False
                currentRegLbl.Visible = False
                label9.Visible = False
                fanModeLbl.Visible = False
                fanModeCombo.Visible = False
                currentLimitMinLbl.Text = device.MinCurrentLimit.ToString()
                currentLimMaxLbl.Text = device.MaxCurrentLimit.ToString()
                currentLimitTrk.Minimum = Convert.ToInt32(device.MinCurrentLimit * 10)
                currentLimitTrk.Maximum = Convert.ToInt32(device.MaxCurrentLimit * 10)
                currentRegTrk.Visible = False
                brakingMinLbl.Text = "0"
                brakingStrengthTrk.Minimum = 0
            Case DeviceID.PN_DCC1003
                backEmfSensingChk.Visible = False
                backEMFLabel.Visible = False
                backEMFTxt.Visible = False
                currentRegMinLbl.Visible = False
                currentRegMaxLbl.Visible = False
                currentRegLbl.Visible = False
                label9.Visible = False
                fanModeLbl.Visible = False
                fanModeCombo.Visible = False
                currentRegTrk.Visible = False
                brakingMinLbl.Text = "0"
                brakingStrengthTrk.Minimum = 0
                brakingStrengthTrk.Visible = True
                brakingTxt.Visible = True
                brakingLbl.Visible = True
                brakingMinLbl.Visible = True
                brakingMaxLbl.Visible = True
                currentLimitTrk.Minimum = Convert.ToInt32(device.MinCurrentLimit * 10)
                currentLimitTrk.Maximum = Convert.ToInt32(device.MaxCurrentLimit * 10)

                currentLimitMinLbl.Text = currentLimitTrk.Minimum.ToString()
                currentLimMaxLbl.Text = currentLimitTrk.Maximum.ToString()

                currentLimitTrk.Value = Convert.ToInt32(device.MinCurrentLimit * 10)
                currentLimitLbl.Text = attachedDevice.MinCurrentLimit.ToString() + "A"

                brakingStrengthTrk.TickFrequency = 100 'device only supports On/off For braking duty cycle
            Case Else
                brakingStrengthTrk.Visible = True
                brakingTxt.Visible = True
                brakingLbl.Visible = True
                brakingMinLbl.Visible = True
                brakingMaxLbl.Visible = True
                backEmfSensingChk.Visible = True
                backEMFLabel.Visible = True
                backEMFTxt.Visible = True
                Try
                    device.BackEMFSensingState = backEmfSensingChk.Checked
                Catch ex As PhidgetException
                    errorBox.addMessage("Error setting BackEMFSensingState: " + ex.Message)
                End Try
                Try
                    attachedDevice.TargetBrakingStrength = 0
                Catch ex As PhidgetException
                    errorBox.addMessage("Error setting BrakingStrength: " + ex.Message)
                End Try
        End Select

        settingsBox.Visible = True
        dutyCycleTxt.Text = "Unknown"
        backEMFTxt.Text = "Unknown"
        motorStatusBox.Visible = True
    End Sub

    Private Sub device_Detach(ByVal sender As Object, ByVal e As DetachEventArgs) Handles device.Detach
        PhidgetInfoBox1.Clear()
        settingsBox.Visible = False
        motorStatusBox.Visible = False
    End Sub

    Private Sub device_Error(ByVal sender As Object, ByVal e As Phidget22.Events.ErrorEventArgs) Handles device.Error
        errorBox.addMessage(e.Description)
    End Sub

    Private Sub dtycycletrk_Scroll(sender As Object, e As EventArgs) Handles dtycycletrk.Scroll
        Try
            device.TargetVelocity = dtycycletrk.Value / dtycycletrk.Maximum
            dutyTxt.Text = dtycycletrk.Value.ToString() + "%"
        Catch ex As PhidgetException
            errorBox.addMessage("Error setting duty cycle: " + ex.Message)
        End Try
    End Sub

    Private Sub backEmfSensingChk_CheckedChanged(sender As Object, e As EventArgs) Handles backEmfSensingChk.CheckedChanged
        Try
            device.BackEMFSensingState = backEmfSensingChk.Checked
        Catch ex As PhidgetException
            errorBox.addMessage("Error setting back EMF sensing: " + ex.Message)
        End Try
    End Sub

    Private Sub accelerationTrk_Scroll(sender As Object, e As EventArgs) Handles accelerationTrk.Scroll
        Try
            device.Acceleration = accelerationTrk.Value / 100.0
            accelTxt.Text = Convert.ToInt32(device.Acceleration).ToString() + " %/s"
        Catch ex As PhidgetException
            errorBox.addMessage("Error setting acceleration: " + ex.Message)
        End Try
    End Sub

    Private Sub brakingDutyCycleTrk_Scroll(sender As Object, e As EventArgs) Handles brakingStrengthTrk.Scroll
        Try
            If device.DeviceID = DeviceID.PN_DCC1003 Then
                If brakingStrengthTrk.Value / 100 >= 0.5 Then
                    brakingTxt.Text = "1"
                    device.TargetBrakingStrength = 1
                Else
                    brakingTxt.Text = 0
                    device.TargetBrakingStrength = 0
                End If
            Else
                brakingTxt.Text = (brakingStrengthTrk.Value / 100.0).ToString()
                device.TargetBrakingStrength = brakingStrengthTrk.Value / 100.0
            End If
        Catch ex As PhidgetException
            errorBox.addMessage("Error setting braking duty cycle: " + ex.Message)
        End Try
    End Sub

    Private Sub duty_cycle_change(sender As Object, e As Phidget22.Events.DCMotorVelocityUpdateEventArgs) Handles device.VelocityUpdate
        dutyCycleTxt.Text = e.Velocity.ToString("F2")
    End Sub

    Private Sub back_emf_change(sender As Object, e As Phidget22.Events.DCMotorBackEMFChangeEventArgs) Handles device.BackEMFChange
        backEMFTxt.Text = e.BackEMF.ToString()
    End Sub

    Private Sub currentLimitTrk_Scroll(sender As Object, e As EventArgs) Handles currentLimitTrk.Scroll
        Try
            Select Case (device.DeviceID)
                Case DeviceID.PN_DCC1001
                    device.CurrentLimit = Convert.ToDouble(currentLimitTrk.Value / 10.0)
                Case Else
                    device.CurrentLimit = Convert.ToDouble(currentLimitTrk.Value)
            End Select
            currentLimitLbl.Text = device.CurrentLimit.ToString()
        Catch ex As PhidgetException
            errorBox.addMessage("Error setting current limit: " + ex.Message)
        End Try
    End Sub

    Private Sub currentRegTrk_Scroll(sender As Object, e As EventArgs) Handles currentRegTrk.Scroll
        Try
            device.CurrentRegulatorGain = Convert.ToDouble(currentRegTrk.Value)
            currentRegLbl.Text = device.CurrentRegulatorGain.ToString()
        Catch ex As PhidgetException
            errorBox.addMessage("Error setting current regulator gain: " + ex.Message)
        End Try
    End Sub

    Private Sub fanModeCombo_SelectedIndexChanged(sender As Object, e As EventArgs) Handles fanModeCombo.SelectedIndexChanged
        Dim combo As ComboBox = CType(sender, ComboBox)

        Try
            If combo.SelectedIndex = 0 Then
                device.FanMode = FanMode.On
            ElseIf combo.SelectedIndex = 1 Then
                device.FanMode = FanMode.Off
            Else
                device.FanMode = FanMode.Auto
            End If
        Catch ex As PhidgetException
            errorBox.addMessage("Error setting fan mode: " + ex.Message)
        End Try
    End Sub
End Class
